<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>
<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách đăng ký</h2>
        <div class="container jumbotron">
          <div class="row">
            <div class="col-2">
              <label for="">Trạng thái order</label>
            </div>
            <div class="col-3">
              <select name="" id="select-order">
                <option value="all">All</option>
                <option value="open">Open</option>
                <option value="confirmed">Confirmed</option>
                <option value="cancel">Cancel</option>
              </select>
            </div>
            <div class="col-2">
              <label for="">Last Name</label>
            </div>
            <div class="col-3">
                <select name="" id="select-pizzatype">
                    <option value="all">All</option>
                    <option value="hawaii">Hawaii</option>
                    <option value="bacon">Bacon</option>
                    <option value="seafood">Seafood</option>
                  </select>
            </div>
            <div class="col-2">
              <button class="btn btn-primary filter-user">Filter</button>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>OrderID</th>
              <th>Kích Cỡ Combo</th>
              <th>Loại Pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi Tiết</th>
            </tr>
        </table>
      </div>

      <!-- modal đơn hàng -->
     
      <div class="modal"id="modal-detail" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Modal title</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">OrderID</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-orderid" class="form-control">
                            </div>
                        </div>
                    </div>   
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Kích Cỡ</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-kichco" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Đường Kính</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-duongkinh" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Sườn</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-suon" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Salad</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-salad" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Pizza Size</label>
                            </div>
                            <div class="col-8">
                                <select name="" id="select-pizza" class="form-control">All</select>
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Loại Pizza</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-loaipizza" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Thành Tiền</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-thanhtien" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Giảm Giá</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-giamgia" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Voucher ID</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-voucher" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Đồ Uống</label>
                            </div>
                            <div class="col-8">
                                <select name="" id="inp-douong" class="form-control">All</select>
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Số Lượng Nước Uống</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-soluongnuocuong" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Họ Và Tên</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-hovaten" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Email</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-email" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Số Điện Thoại</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-sodienthoai" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Địa Chỉ</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-diachi" class="form-control">
                            </div>
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Lời Nhắn</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-loinhan" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Trạng Thái Đơn Hàng</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-trangthai" class="form-control">
                            </div>
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Ngày Tạo Đơn</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-ngaytaodon" class="form-control">
                            </div>
                        </div>
                    </div> 
                    <div class="col-12">
                        <div class="row">
                            <div class="col-4">
                                <label for="" class="font-weight-bold">Ngày Cập Nhật</label>
                            </div>
                            <div class="col-8">
                                <input type="text" id="inp-ngaycapnhat" class="form-control">
                            </div>
                        </div>
                    </div> 
                
            <div class="modal-footer">
              <button type="button" class="btn btn-success confirm-order">Confirm</button>
              <button type="button" class="btn btn-danger cancel-order" data-dismiss="modal">Cancel</button>
            </div>
          </div>
        </div>
      </div>

</body>
</html>
<script>
    $(document).ready(function(){

    const gCOLUMN_ID = 0;
    const gCOLUMN_KICH_CO = 1;
    const gCOLUMN_LOAI_PIZZA = 2;
    const gCOLUMN_NUOC_UONG = 3;
    const gCOLUMN_THANH_TIEN = 4 ;
    const gCOLUMN_FULLNAME = 5;
    const gCOLUMN_PHONE = 6;
    const gCOLUMN_STATUS = 7;
    const gCOLUMN_ACTION = 8;
    

    const gCOL_NAME = ["orderId","kichCo" , "loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","action"]

    var gStatus = {
        trangThai : "confirmed"
    } ;
    var gStatus1 = {
        trangThai : "cancel"
    }
    var gPizzaSize = ["S" , "M" , "L"];

    var gUser = {
        users:[] ,
        filterUser : function(paramFilter){
            var vResul = [] ;
            vResul = this.users.filter(function(user){
          // đây là cách lọc chỉ tương đối và là live nên chỉ cần nhập 1 vài chữ là sẽ ra tên luôn
          return ((paramFilter.trangThai == "All" || user.trangThai.toUpperCase().includes(paramFilter.trangThai.toUpperCase()))
          &&      (paramFilter.loaiPizza == "All" || user.loaiPizza.toUpperCase().includes(paramFilter.loaiPizza.toUpperCase()))) ;
        })
        return vResul
        }
        
    }
    var gUserTable = $("#user-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gCOL_NAME[gCOLUMN_ID] },
          { "data" : gCOL_NAME[gCOLUMN_KICH_CO] },
          { "data" : gCOL_NAME[gCOLUMN_LOAI_PIZZA] },
          { "data" : gCOL_NAME[gCOLUMN_NUOC_UONG] },
          { "data" : gCOL_NAME[gCOLUMN_THANH_TIEN] },
          { "data" : gCOL_NAME[gCOLUMN_FULLNAME] },
          { "data" : gCOL_NAME[gCOLUMN_PHONE] },
          { "data" : gCOL_NAME[gCOLUMN_STATUS] },
          { "data" : gCOL_NAME[gCOLUMN_ACTION] }
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs":[ 
      {
          "targets": gCOLUMN_ACTION,
          "defaultContent": "<button class = 'btn btn-primary detail-click'>Chi Tiết</button>"
      },
    ]
    });
    
    $(document).on("click" , ".detail-click", function(){
        onBtnDetailClick(this);
    });
    $(document).on("click" , ".filter-user" , function(){
        filterUser();
    })
    $(document).on("click" , ".confirm-order" , function(){
        getDataToUpdateOrder(this);
    })
    $(document).on("click" , ".cancel-order" , function(){
        getDataToUpdateOrder1(this);
    })
    function getDataToUpdateOrder(paramDetail){
        //Lấy datatable row
        console.log(gUser.users.id)

        callApiToUpdate();

        callApiGetAllOrder();

        loadDataToTable(gUser.users);

        $("#modal-detail").modal("hide");
    }
    function getDataToUpdateOrder1(paramDetail){
        //Lấy datatable row
        console.log(gUser.users.id)

        callApiToUpdate1();

        callApiGetAllOrder();

        loadDataToTable(gUser.users);

        $("#modal-detail").modal("hide");
    }

    function onBtnDetailClick(paramDetail){
        var vRowSelected = $(paramDetail).parents('tr');
        //Lấy datatable row
        var vDatatableRow = gUserTable.row(vRowSelected); 
        //Lấy data của dòng 
        var vUserData = vDatatableRow.data();

        gUser.users.id = vUserData.id;
    
        gUser.users.orderId = vUserData.orderId

        console.log(vUserData.orderId)

        callApiToGetOrderDetail();

        $("#inp-orderid").val(vUserData.orderId);
        $("#inp-kichco").val(vUserData.kichCo);
        $("#inp-duongkinh").val(vUserData.duongKinh);
        $("#inp-suon").val(vUserData.suon);
        $("#inp-salad").val(vUserData.salad);
        $("#inp-loaipizza").val(vUserData.loaiPizza);
        $("#inp-voucher").val(vUserData.idVourcher);
        $("#inp-thanhtien").val(vUserData.thanhTien);
        $("#inp-giamgia").val(vUserData.giamGia);
        $("#inp-douong").val(vUserData.idLoaiNuocUong);
        $("#inp-soluongnuocuong").val(vUserData.soLuongNuoc);
        $("#inp-hovaten").val(vUserData.hoTen);
        $("#inp-email").val(vUserData.email);
        $("#inp-sodienthoai").val(vUserData.soDienThoai);
        $("#inp-diachi").val(vUserData.diaChi);
        $("#inp-loinhan").val(vUserData.loiNhan);       
        $("#inp-trangthai").val(vUserData.trangThai);
        $("#inp-ngaytaodon").val(vUserData.ngayTao);
        $("#inp-ngaycapnhat").val(vUserData.ngayCapNhat);


        $("#modal-detail").modal("show")

    }

    callApiGetAllOrder();
   

    function filterUser(){
        var vFilter = {
            trangThai:"",
            loaiPizza:""
        }

        getSelectData(vFilter)

      var filterUser = gUser.filterUser(vFilter);

      loadDataToTable(filterUser)
    }
    function callApiToUpdate(){
        $.ajax({
            async:false,
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gUser.users.id,
            type: "PUT",
            contentType:"application/json;charset=UTF-8",
            data:JSON.stringify(gStatus),
        success:function(res){
            console.log(JSON.stringify(res));
            
            },
        error:function(error){
            console.assert(error)
            }
        });
    }
    function callApiToUpdate1(){
        $.ajax({
            async:false,
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gUser.users.id,
            type: "PUT",
            contentType:"application/json;charset=UTF-8",
            data:JSON.stringify(gStatus1),
        success:function(res){
            console.log(JSON.stringify(res));
            
            },
        error:function(error){
            console.assert(error)
            }
        });
    }
    function getDrinkListAjax(){
        $.ajax({
            async:false,
            url: "http://42.115.221.44:8080/devcamp-pizza365/drinks/" ,
            type: "GET",
            contentType:"application/json;charset=UTF-8",
            dataType:"json",
        success:function(res){
            loadDataDrinkToSelect(res);
            },
        error:function(error){
            console.assert(error)
            }
        });
    }
    getDrinkListAjax();
    loadDataPizzaToSelect(gPizzaSize);

    function callApiGetAllOrder(){
        $.ajax({
            async:false,
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
            type: "GET",
            dataType:'json',
        success:function(res){
            console.log(JSON.stringify(res));
            gUser.users = res ;
            loadDataToTable(gUser.users)
            },
        error:function(error){
            console.assert(error)
            }
        });
    }
    function callApiToGetOrderDetail(){
        $.ajax({
            async:false,
            url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + gUser.users.orderId,
            type: "GET",
            dataType:'json',
        success:function(res){
            console.log(JSON.stringify(res));
            },
        error:function(error){
            console.assert(error)
            }
        });
    }
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gUserTable.clear();
      //Cập nhật data cho bảng 
      gUserTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gUserTable.draw();
    }
    function loadDataDrinkToSelect(paramDrink){
        $.each(paramDrink , function (i , item){
            $("#inp-douong").append($("<option>" , {
                text:item.tenNuocUong,
                value:item.maNuocUong
            }))
        })
    }
    function loadDataPizzaToSelect(paramPizza){
        $.each(paramPizza , function (i , item){
            $("#select-pizza").append($("<option>" , {
                text:item,
                value:item.toLowerCase()
            }))
        })
    }
   

    function getSelectData(paramData){
        paramData.trangThai = $("#select-order option:selected").text()
        paramData.loaiPizza = $("#select-pizzatype option:selected").text()
    }
})

</script>